#pragma once
#pragma execution_character_set("utf-8")
#include <iostream>
#include <Python.h>
#include<omp.h>
#include"fstream"
#include"string"
#include"cmath"
namespace API {
	using namespace System::Windows::Forms;
	//#include"windows.h"
	using std::string;
	using std::ifstream;
	class api {
	private:
		string * input;
		string *output;
		int len;
		PyObject *pModule, **pFunc;
		string * sepsequence(string & s);
		double theta2(string &input, string *segg, int len_seg, double *MV_D, double * Nucl, int lambda, int *index, int i, double MV_mean, double Nucl_mean, double Nucl_std, double MV_std);
		double theta1(int lambda, string *segg, int len_segg, string &seg, double *MV_D, double *Nucl, int *index, double MV_mean, double Nucl_mean, double Nucl_std, double MV_std);
		double theta2q(double **se, int lambda, int *index, int q, double * mean, double * std, int *select);
		double J(double **se, int lambda, int *index, int q, double * mean, double * std, int *select, int num);
		double theta1q(int lambda, string *segg, int len_segg, string &seg, double ** se, int *index, double * mean, double *std, int *select, int t);
		double * pseknc(string & input, int lambda);
		double * KMM(string & line);
		double * run(string & s, string & out);
		int initial();
		void end();
		double ** pseknct(string * input, string *outputfile, int len);
	public:
		api() { initial(); }
		int *pse_api(int type, ProgressBar ^p);
		double ** start(int len, string *input);
		double * tztq(string & input, int lambda, int t, double w, int * select);
	};
}